package edu.sc.seis.darkMagic;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.Constructor;
import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.Servant;

import edu.iris.Fissures.IfSeismogramDC.DataCenterPOA;
import edu.sc.seis.cormorant.AbstractController;
import edu.sc.seis.fissuresUtil.Alohomora;

public class DarkMagicController extends AbstractController {

    public DarkMagicController(Properties confProps,
                               String serverPropName,
                               ORB orb) throws Exception {
        super(confProps, serverPropName, orb);
        try {
            Fluffy.setPasswordProps(Alohomora.getPasswordProps(confProps));
        } catch(FileNotFoundException e) {
            logger.error("Unable to find darkmagic password file.", e);
            throw new RuntimeException(e);
        } catch(IOException e) {
            logger.error("Unable to load darkmagic password file.", e);
            throw new RuntimeException(e);
        }
        String wrappedClassName = confProps.getProperty(getPropertyPrefix()
                + "wrappedController", MockFluffyController.class.getName());
        Class wrappedClass = Class.forName(wrappedClassName);
        Constructor cs = wrappedClass.getConstructor(new Class[] {Properties.class,
                                                                  String.class,
                                                                  ORB.class});
        wrapped = (FluffyController)cs.newInstance(new Object[] {confProps,
                                                                 serverPropName,
                                                                 orb});
        darkMagicServant = new FluffyDataCenterWrapper(wrapped);
    }

    public Servant getServant() {
        return darkMagicServant;
    }

    FluffyController wrapped;

    DataCenterPOA darkMagicServant;

    private static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(DarkMagicController.class);
}
