package edu.sc.seis.darkMagic;

import org.omg.PortableInterceptor.Current;
import org.omg.PortableInterceptor.CurrentHelper;
import org.omg.PortableInterceptor.ORBInitInfo;
import org.omg.PortableInterceptor.ORBInitializer;

public class FluffyInitializer extends org.omg.CORBA.LocalObject implements
        ORBInitializer {

    public void pre_init(ORBInitInfo info) {
        try {
            logger.debug("Fluffy pre_init");
            Current piCurrent = CurrentHelper.narrow(info.resolve_initial_references("PICurrent"));
            // Allocate a slot id to use for the interceptor to indicate
            // that it is making an outcall. This is used to avoid
            // infinite recursion.
            int outCallIndicatorSlotId = info.allocate_slot_id();
            // Create (with the above data) and register the client
            // side interceptor.
            //
            // we assume here that the cmd line props have already been read in
            // via the Initializer
            // This works as long as we are in a cormorant system, but that
            // might not be the case...
            Fluffy fluffy = new Fluffy(piCurrent, outCallIndicatorSlotId);
            info.add_server_request_interceptor(fluffy);
            logger.debug("Fluffy registered with orb");
        } catch(Throwable t) {
            logger.error("Exception adding Fluffy to orb", t);
        }
    }

    public void post_init(ORBInitInfo info) {}

    private static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(FluffyInitializer.class);
}
